/*      StringToInteger.cxx -- definition of a C++ function
        that converts a numeric string to an integer and that
        also returns a success or error flag.

        Dr. Dale Parson, Fall, 2008.
        Function "from_string" definition found at
        http://www.codeguru.com/forum/showthread.php?t=231054, Sept., 2008.
*/
#include "StringToInteger.h"
#include <string>
#include <sstream>

// Use a template function and stream type conversion operators
// to convert the string to an int with error checking.
// Returns true with conversion output in parameter t if string is valid,
// else returns false.
template <class T>
static bool
from_string(T& t, const std::string& s, std::ios_base& (*f)(std::ios_base&)) {
    std::istringstream iss(s);
    return !(iss >> f >> t).fail();
}

int
StringToInteger(const char *stringToConvert, bool &isvalid) {
    int result = 0 ;
    if (from_string<int>(result, std::string(stringToConvert), std::dec)) {
        isvalid = true ;
    } else {
        result = 0 ;
        isvalid = false ;
    }
    return result ;
}
