/*      StringToInteger.h -- declaration of a C++ function
        that convert a numeric string to an integer and that
        also returns a success or error conversion flag.

        Dr. Dale Parson, Fall, 2008.
*/
#ifndef STRINGTOINTEGER_H
#define STRINGTOINTEGER_H

/*
        Function            StringToInt

        Converts a numeric base-10 string to an int and returns the
        value, along with a success flag in reference parameter isvalid.

        Parameters:

            INPUT

            stringToConvert a null-terminated character array, typically
                            holding a base-10 numeric string.

            OUTPUT

            isvalid         a boolean output reference parameter,
                            set to true if stringToConvert is a valid base-10
                            numeric string, else set to false before return

        RETURN value:       int equivalent of stringToConvert when latter
                            is a numeric string (with isvalid set to true),
                            or 0 when stringToConvert is an invalibase-10
                            string (with isvalid set to false).

        Side Effects:       none

        Preconditions:
        
            stringToConvert must be a null-terminated string.

        Postconditions:

            isvalid set to true for valid base-10 stringToConvert with a
            valid return value.

            isvalid set to false on an invalid base-10 string with a
            return value of 0.

        Invariants:         none
*/

int
StringToInteger(const char *stringToConvert, bool &isvalid) ;

#endif
